Imports System.text.RegularExpressions

Module Module1
    Public Sub Main()
        TestIt()
        CleanseData(String.Empty)
    End Sub 'Main

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Replaces non printable control characters (ASCII 0 - 31) with a space
    ''' </summary>
    ''' <param name="textToCleanse">Text containing data which needs to be cleansed</param>
    ''' <param name="changeCount">Optional counter which will return the number of unprintable characters found</param>
    ''' <returns>Input string with all unprintable characters (ASCII 0 - 31) changed to spaces</returns>
    ''' <remarks>
    ''' </remarks>
    ''' -----------------------------------------------------------------------------
    Private Function CleanseData(ByVal textToCleanse As String, _
                                 Optional ByRef changeCount As Integer = 0) As String
        ' Create illegal character string
        Dim badChars As String = String.Empty
        For index As Integer = 0 To 31
            ' Use ChrW instead of Chr to avoid boxing
            badChars &= ChrW(index)
        Next

        ' Build RegEx pattern - square brackets say match any one of them
        Dim pattern As String = "[" & badChars & "]"

        ' Are there any illegal characters
        If Regex.IsMatch(textToCleanse, pattern) Then
            ' Count them
            changeCount = Regex.Matches(textToCleanse, pattern).Count
            ' Convert them to spaces
            textToCleanse = Regex.Replace(textToCleanse, pattern, " ")
        End If
        Return textToCleanse
    End Function 'CleanseData

    Private Sub TestIt()
        ' Characters separated by 2 spaces
        Dim text0 As String = String.Empty
        ' ASCII codes separated by 1 space
        Dim text1 As String = String.Empty

        ' Create illegal character string
        Dim badChars As String = String.Empty
        For index As Integer = 0 To 31
            ' Use ChrW instead of Chr to avoid boxing
            badChars &= ChrW(index)
            ' Combine bad1 + A + bad2 + B, etc
            text0 &= ChrW(index) & "  " & ChrW(index + 65) & "  "
            text1 &= index.ToString("00 ") & (index + 65).ToString("00 ")
        Next

        ' Build RegEx pattern - square brackets say match any one of them
        Dim pattern As String = "[" & badChars & "]"

        ' Are there any illegal characters
        If Regex.IsMatch(text0, pattern) Then
            MsgBox("Before: ~" & text1 & "~" & vbNewLine & "Before: ~" & text0 & "~")

            ' Count them
            MsgBox("Bad Chars: " & Regex.Matches(text0, pattern).Count.ToString)

            ' Convert them to spaces
            text0 = Regex.Replace(text0, pattern, " ")

            text1 = String.Empty
            For index As Integer = 0 To 190 Step 3
                text1 &= Asc(text0.Substring(index, 1)).ToString("00 ")
            Next
            MsgBox("After: ~" & text1 & "~" & vbNewLine & "After: ~" & text0 & "~")
        End If
    End Sub 'TestIt
End Module
